-------------------------------------------------------------------------------
--! @file       SB.vhd
--! @author     Ahmed Ferozpuri
--! @brief      SubBytes (SB) for PRIMATEs
-------------------------------------------------------------------------------
LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY SB IS
	GENERIC (V : INTEGER := 200;
				isINV : INTEGER := 0);
	PORT(	V_i : IN  std_logic_vector(V-1 DOWNTO 0);
			V_o : OUT  std_logic_vector(V-1 DOWNTO 0)
		);
END SB;

ARCHITECTURE behavioral OF SB IS

BEGIN
	GEN_SB0X:IF isINV=0 GENERATE
		GEN_SB0Xi: FOR i IN 0 TO V/5-1 GENERATE
			rom: ENTITY work.SBOX(behavioral)
				PORT MAP(addr => V_i(i*5+4 DOWNTO i*5), do => V_o(i*5+4 DOWNTO i*5));
		END GENERATE GEN_SB0Xi;
	END GENERATE GEN_SB0X;	

	GEN_SB0XINV:IF isINV=1 GENERATE
		GEN_SB0Xi: FOR i IN 0 TO V/5-1 GENERATE
			rom: ENTITY work.SBOXINV(behavioral)
				PORT MAP(addr => V_i(i*5+4 DOWNTO i*5), do => V_o(i*5+4 DOWNTO i*5));
		END GENERATE GEN_SB0Xi;
	END GENERATE GEN_SB0XINV;
END behavioral;